import 'dart:async';

import 'package:yona/yona.dart';

void main() async {
  var node1 = await Node.create(await Crypto.genSK(),
      NetAddr.fromString("yonafediverse.com:7777"), MemCache());
  await node1.publish("node1");
  var sent = 0;
  var set = Set<int>.identity();
  node1.stream.forEach((input) {
    if (set.add(input.sentAt.millisecondsSinceEpoch)) {
      var lost = sent - set.length;
      print(DateTime.now());
      print("lost $lost");
    }
  });
  node1.delay = Duration(milliseconds: 50);
  var timer = Timer.periodic(Duration(milliseconds: 10), (timer) async {
    try {
      await node1.send(Output(node1.pk(), 1, [
        [0]
      ]));
      sent++;
      print("sent $sent");
    } catch (error) {
      print(error);
    }
  });
  Timer(Duration(seconds: 5), () => timer.cancel());
}
