import 'dart:async';

import 'package:yona/yona.dart';

void main() async {
  var node1 = await Node.create(
      await Crypto.genSK(), NetAddr.fromString("yonafediverse.com:7777"));
  await node1.publish("node1");
  var sent = 0;
  var set = Set<int>.identity();
  node1.stream.forEach((packet) {
    set.add(packet.sentAt.millisecondsSinceEpoch);
    var lost = sent - set.length;
    print("lost $lost");
  });
  var timer = Timer.periodic(Duration(milliseconds: 500), (timer) async {
    await node1.send(Output(node1.pk(), 1, [await Crypto.randBytes(33)]));
    sent++;
    print("sent $sent");
  });
  Timer(Duration(seconds: 50), () => timer.cancel());
}
