import 'dart:typed_data';

class Utils {
  static bool equal<T>(Iterable<T> a, Iterable<T> b) {
    var i = 0;
    for (var v in a) {
      if (b.length <= i) {
        return false;
      }
      if (b.elementAt(i) != v) {
        return false;
      }
      i++;
    }
    return true;
  }

  static Uint8List int64ToBinary(int n) {
    var b = Uint8List(8);
    b.buffer.asByteData(0).setInt64(0, n);
    return b;
  }

  static int parseBinaryToInt(List<int> b, [Endian endian = Endian.big]) {
    return Uint8List.fromList(b).buffer.asByteData(0).getInt64(0, endian);
  }
}
