import 'dart:math';

import 'package:test/test.dart';

import 'package:yona/yona.dart';

void main() async {
  test("simple", () async {
    var a = await Crypto.genSK();
    var b = await Crypto.genSK();
    var msg = Output(Crypto.derivePK(b), Random.secure().nextInt(255),
        [await Crypto.randBytes(33), await Crypto.randBytes(23)]);
    var msg2 = await Input.decrypt(await msg.encrypt(a, -1), b);
    for (var i = 0; i < msg2.content.length; i++) {
      assert(Utils.equal(msg2.content[i], msg.content[i]));
    }
    assert(Utils.equal(msg2.from, Crypto.derivePK(a)));
    assert(Utils.equal(msg.to, Crypto.derivePK(b)));
    assert(msg2.kind == msg.kind);
    assert(msg2.sentAt.microsecondsSinceEpoch ==
        msg.sentAt.microsecondsSinceEpoch);
  });
}
