import 'package:test/scaffolding.dart';
import 'package:yona/yona.dart';

void main() async {
  test("node", () async {
    const n = 5;
    List<Node> nodes = [];
    for (var i = 0; i < n; i++) {
      var node = await Node.create(await Crypto.genSK(),
          NetAddr.fromString("yonafediverse.com:7777"), MemCache());
      node.delay = Duration(milliseconds: 50);
      if (i > 0) {
        var pre = nodes[i - 1];
        node.stream.forEach((packet) async {
          await node.send(Output(pre.pk(), 1, packet.content));
        });
      } else {
        node.stream.timeout(Duration(seconds: n * 2)).forEach((packet) {
          print(((DateTime.now().microsecondsSinceEpoch -
                      Utils.parseBinaryToInt(packet.content[0])) /
                  1e+6) /
              n);
          for (var node in nodes) {
            node.close();
          }
        });
      }
      await node.publish(i.toString());
      nodes.add(node);
    }
    await nodes.first.send(Output(nodes.last.pk(), 1,
        [Utils.int64ToBinary(DateTime.now().microsecondsSinceEpoch)]));
  });
}
