import 'dart:convert';
import 'dart:typed_data';

import 'package:test/test.dart';
import 'package:yona/yona.dart';

void main() async {
  test("equal<int>", () async {
    var list1 = await Crypto.randBytes(100);
    var list2 = List<int>.from(list1);
    var list3 = List<int>.from(list1);
    list3[list3.length - 1] += 1;
    assert(true == Utils.equal(list1, list2));
    assert(false == Utils.equal(list1, list3));
  });
  test("equal<Uint8List>", () async {
    var list1 = await Crypto.randBytes(100);
    var list2 = Uint8List.fromList(list1.toList());
    var list3 = Uint8List.fromList(list1.toList());
    list3[list3.length - 1] += 1;
    assert(true == Utils.equal(list1, list2));
    assert(false == Utils.equal(list1, list3));
  });
  test("equal<String>", () async {
    var list1 = base64Encode(await Crypto.randBytes(100)).split('');
    var list2 = list1.join('').split('');
    var list3 = [""];
    assert(true == Utils.equal(list1, list2));
    assert(false == Utils.equal(list1, list3));
  });
  test("int B", () {
    var now = DateTime.now().microsecondsSinceEpoch;
    var b = Utils.parseBinaryToInt(Utils.int64ToBinary(now));
    assert(now == b);
    var l = List<int>.generate(8, (index) => index == 0 ? 0 : 255);
    var l2 = Utils.int64ToBinary(Utils.parseBinaryToInt(l));
    assert(Utils.equal(l, l2));
  });
}
